#include <iostream>
#include <string>
#include <conio.h>
#include "Student.h"
#include "Validator.h"
using namespace std;

int main() {
	bool nameVerify(string);
	bool courseVerify(string);
	bool noRepeat();
	void enterCourses(Student* student);
	string enterName();

	string name = "";

	while (true) {
		Student student1(enterName());
		enterCourses(&student1);
		cout << student1 << endl;

		//CODE FOR DEMONSTRATING COPY CONSTRUCTOR
		Student student2(student1);
		
		student2.setName(enterName());
		cout << student2 << endl;
		student1.resetCourses();
		cout << student1 << endl;
		cout << student2 << endl;

		// CODE FOR DEMONSTRATING ASSIGNMENT OPERATOR
		Student student3;
		student3 = student2;
		student3.setName(enterName());
		cout << student3 << endl;
		student2.resetCourses();
		cout << student3 << endl;
		cout << student2 << endl;
		cout << student1 << endl;

		if (noRepeat()) {
			break;
		}
	}

	_getch();

	return 0;
} //end main.

string enterName() {
	Validator validator;
	while (true) {
		string response = "";
		cout << "Input name for student: ";
		if (validator.input(&response)) {
			if (validator.nameVerify(response))
			{
				return response;
			}
			else
			{
				cout << "INPUT FAILURE: Please try again. (Only letters and spaces are permitted.) ";
			}// end verify valid input
		}
		cout << endl;
	}
}

void enterCourses(Student* student) {
	Validator validator;
	cout << "COURSE ENTRY MODE. PRESS THE ESCAPE KEY TO STOP ENTERING COURSES." << endl;
	while (true) {
		string response = "";
		cout << "Input course name for student " << student->getName() << ": ";
		if (validator.input(&response)) {
			if (validator.courseVerify(response))
			{
				//add item to array.
				student->addCourse(response);
				cout << "Added: " << response << " to course list for student " << student->getName() << endl;
			}
			else
			{
				cout << "INPUT FAILURE: Please try again. (Only letters, numbers and spaces are permitted. Course names can not end with a space.) " << endl;
			}// end verify valid input
		}
		else
		{
			cout << "END Course entry mode." << endl;
			break;
		}//else stop the loop

	}
}

bool noRepeat() {
	Validator validator;
	while (true) {
		string response = "";
		cout << "Do you want to run the program again? (Y or N): ";
		if (validator.input(&response)) {
			if (validator.yesNoVerify(response))
			{
				if (response == "N" || response == "n") {
					return true;
				}
				else {
					return false;
				}
			}
			else
			{
				cout << "INPUT FAILURE: Please try again. (Only letters and spaces are permitted.) ";
			}// end verify valid input
		}
		cout << endl;
	}
}