#define _SCL_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <string.h>
#include <string>
#include <iostream>

#include "Student.h"
using namespace std;


// Constructors
Student::Student() : courseListCapacity(2), numCourses(0) {
	courseList = new string[courseListCapacity];
}

Student::Student(string name) : name(name), courseListCapacity(2), numCourses(0){
	courseList = new string[courseListCapacity];
}

//Copy constructor
Student::Student(const Student& obj) : name(obj.getName()), courseListCapacity(obj.getCapacity()), numCourses(obj.getNumCourses()) {
	cout << "====== Copy constructor has fired. ======" << endl;
	courseList = new string[courseListCapacity];
	for (int i = 0; i < numCourses; i++) {
		// ********************************************* Question for Dave ********************************************
		//why does this work if this is considered a PRIVATE property?
		courseList[i] = obj.courseList[i]; 
	}
}

//Destructor
Student::~Student() {
	cout << "====== Destructor has fired.  ======" << endl;
	if (courseList != NULL) {
		delete[]courseList;
		courseList = NULL;
	}
}


//Overload = operator (ASSIGNMENT OPERATOR)
Student& Student::operator=(const Student& right)
{
	cout << "====== Assignment operator (=) has fired. ======" << endl;
	if (courseListCapacity != right.courseListCapacity) {
		delete[]courseList;
		courseList = new string[right.courseListCapacity];
	}

	name = right.name;
	courseListCapacity = right.courseListCapacity;
	numCourses = right.numCourses;

	//instead of iterating over just the used courses, I iterated over the entire array in case if the object on the left has the same array size byt MORE courses.
	//The provided example only iterates over the used slots which would not remove courses if the item on the left had more courses than the one on the left but had the same capacity.
	for (int i = 0; i < courseListCapacity; i++) {
		courseList[i] = right.courseList[i];
	}

	return *this;
}

//Double size of array list.
void Student::resizeList() {
	if ((numCourses - courseListCapacity) < 1) {
		int newCapacity = courseListCapacity * 2;
		string *newCourseList = new string[newCapacity];

		for (int i = 0; i < numCourses; i++) {
			newCourseList[i] = courseList[i];
		}

		//Obliterate the old courseList
		delete[] courseList;
		courseList = NULL;
		//Migrate the pointer to the String array from the newCourseList to courseList and modify capacity variable to match new array size.
		//Assign the pointer to the courseList to the same one as newCourseList 
		courseList = newCourseList;
		//Set courseListCapacity to new value.
		courseListCapacity = newCapacity;
		//remove the pointer to newCourseList
		newCourseList = NULL;
	}
}

void Student::addCourse(string courseName)
{
	resizeList();
	courseList[numCourses] = courseName;
	numCourses++;
	//add item to array.
}

string Student::getName() const
{
	return name;
}

void Student::setName(string name) {
	this->name = name;
}

int Student::getCapacity() const {
	return courseListCapacity;
}

int Student::getNumCourses() const {
	return numCourses;
}

string Student::listCourses()
{
	string output = "";
	for (int i = 0; i < numCourses; i++) {
		output = output + courseList[i];
		if (i < numCourses - 1) {
			output = output + " | ";
		}
	}
	return output;
}

//Output the name and list of all courses
string Student::toString() {
	return ("STUDENT NAME: " + getName() + " QUANTITY COURSES: " + to_string(numCourses) + " COURSE LIST: " + listCourses());
}

//Overload << operator
ostream& operator<< (ostream &output, Student& student) {
	output << student.toString();
	return output;
}

//reset numCourses to 0 and empty courseList
void Student::resetCourses() {
	numCourses = 0;
	courseListCapacity = 2;
	delete[] courseList;
	courseList = NULL;
	courseList = new string[courseListCapacity];
	cout << "====== Courselist purge for " << name << " has fired. ======" << endl;
}

